<script>
import { get_currency, get_decimal } from '../../../Helper/helper';
import OrderImages from './order-images'
export default {
  components : {OrderImages},
  props:['order','loading'],
  data(){
    return {
      currency: get_currency(),
      decimal: get_decimal(),
    }
  },
  
  methods:{
    getSelections(items){
      return items.length > 0 ? items.reduce((accu, item) => {
        let price = parseFloat(item.selection_price);
        if (item.pivot) {
          if (item.pivot.price && item.pivot.price > 0) {
            price = parseFloat(item.pivot.price);
          }
        }
        return accu.concat(item.selection_name +' x '+ parseFloat(price).toFixed(this.decimal));
      },[]).join(', '): '';
    },
    getSelectionPrices(items){
      return parseFloat(items.length > 0 ? items.reduce(function(accu, item){
        let price = parseFloat(item.selection_price);
        if (item.pivot) {
          if (item.pivot.price && item.pivot.price > 0) {
            price = parseFloat(item.pivot.price);
          }
        }
        return accu + price;
      },0): 0);
    },
    mrpPrice(item){
      return parseFloat((parseInt(item.quantity) * this.getSelectionPrices(item.menu_item_selections)) + (parseInt(item.quantity) * parseFloat(item.item_mrp || 0)))
    },
    totalPrice(item){
      return parseFloat((parseInt(item.quantity) * this.getSelectionPrices(item.menu_item_selections)) + (parseInt(item.quantity) * parseFloat(item.item_price || 0)))
    },
    discountPrice(item){
      var itemp = parseFloat((this.getSelectionPrices(item.menu_item_selections)) + (parseFloat(item.item_price || 0)));
      var itemmrp = parseFloat((this.getSelectionPrices(item.menu_item_selections)) + (parseFloat(item.item_mrp || 0)));
      return (itemp !== itemmrp ? itemp.toFixed(this.decimal) : ' - ');
      //return (this.mrpPrice(item).toFixed(this.decimal) == this.totalPrice(item).toFixed(this.decimal) ? ' - ' : (this.mrpPrice(item) - this.totalPrice(item)).toFixed(this.decimal))
    }
  }
};
</script>

<template>
  <!-- View Detail Main Start -->
  <div class=" mt-3">
    <div class="col-12">
      <div class="text-center text-danger my-2" v-if="loading">
        <b-spinner class="align-middle"></b-spinner>
        <strong>{{trans.get('__JSON__.Loading...')}}</strong>
      </div>
    </div>
    <div class="table-responsive item-order-main" v-if="!loading">
      <table class="table table-centered table-bordered item-table-main order-detail-mtable">
        <thead>
          <tr>
            <th scope="col" class="item-name-main">{{trans.get('__JSON__.Item Name')}}</th>
            <th scope="col">{{trans.get('__JSON__.Quantity')}}</th>
            <!-- <th scope="col">{{trans.get('__JSON__.Unit Price')}}</th> -->
            <th scope="col">{{trans.get('__JSON__.Original')}}</th>
            <th scope="col">{{trans.get('__JSON__.Discounted Price')}}</th>
            <th scope="col">{{trans.get('__JSON__.Total')}}</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in order.order_item" :key="item.id">
            <td>
              <div class="d-flex">
                {{ item.master_item && item.master_item.item_name }}
                <div v-if="item.menu_item_with_trashed && item.menu_item_with_trashed.item_type == '0'" class="vnicon vnicon--veg"><span class="vnicon-span"></span>
                </div>
                <div v-else-if="item.menu_item_with_trashed && item.menu_item_with_trashed.item_type == '1'" class="vnicon vnicon--nonveg"><span class="vnicon-span"></span>
                </div>
                {{item.menu_item_with_trashed && item.menu_item_with_trashed.item_name}} {{getSelections(item.menu_item_selections)}}
              </div>
            </td>
            <td align="center">
              <p>{{item.quantity}}</p>
            </td>
            <td align="center">
              <!-- <p><span v-html="currency"></span> {{((getSelectionPrices(item.menu_item_selections)) + (parseFloat(item.item_mrp || 0))).toFixed(decimal)}} </p> -->
              <p><span v-html="currency"></span> {{((parseFloat(item.item_mrp || 0))).toFixed(decimal)}} </p>
            </td>
            <!-- <td align="center">
              <p><span v-html="currency"></span> {{mrpPrice(item).toFixed(decimal)}} </p>
            </td> -->
            <td align="center">
              <p><span v-html="currency" v-if="discountPrice(item) != ' - '" ></span> {{discountPrice(item)}} </p>
            </td>
            <td align="center">
              <p><span v-html="currency"></span> {{totalPrice(item).toFixed(decimal)}} </p>
            </td>
          </tr>
          <tr class="saved-amount">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Sub Total')}}<span v-if="order.itemtaxslab > 0" class="tax-slab"> {{ trans.trans('__JSON__.Tax include in item', { tax_name : $auth.setting.tax_name_primary_lang}) }}</span></h6></td>
            <td align="center"> <span v-html="currency"></span> {{parseFloat(order.sub_total || 0).toFixed(decimal)}}<p class="save-amount" v-if="order.itemtaxslab > 0"><span v-html="currency" v-if="order.itemtaxslab > 0"></span> <span v-if="order.itemtaxslab > 0"> {{parseFloat(order.itemtaxslab || 0).toFixed(decimal)}}</span></p></td>
          </tr>
          <tr v-if="order.service_fee > 0">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{$auth.setting.tax_name_primary_lang}}</h6></td>
            <td align="center"> <span v-html="currency"></span> {{parseFloat(order.service_fee || 0).toFixed(decimal)}}</td>
          </tr>
          <tr v-if="order.packaging_charge > 0">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Packaging Charge')}}</h6></td>
            <td align="center"><span v-html="currency"></span> {{parseFloat(order.packaging_charge || 0).toFixed(decimal)}}</td>
          </tr>
          <tr>
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Delivery Fees')}}</h6></td>
            <td align="center"><span v-html="currency"></span> {{parseFloat(order.delivery_fee || 0).toFixed(decimal)}}</td>
          </tr>
          <tr v-if="order.convince_charge > 0">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Convenience Charge')}}</h6></td>
            <td align="center"><span v-html="currency"></span> {{parseFloat(order.convince_charge || 0).toFixed(decimal)}}</td>
          </tr>
          <tr v-if="order.driver_tip > 0">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Driver Tip',{ driver: $auth.setting.driver_name })}}</h6></td>
            <td align="center"><span v-html="currency"></span> {{parseFloat(order.driver_tip || 0).toFixed(decimal)}}</td>
          </tr>
          <tr v-if="(order.reddemed_coupon_order && order.reddemed_coupon_order.coupon.promo_code_type == 1) ||  (order.reddemed_coupon_order && order.reddemed_coupon_order.coupon.promo_code_type == 2)">
            <td colspan="4" align="right">
              <span class="text-right text-danger">{{trans.get('__JSON__.Discount')}}</span>
              <span class="text-right text-danger"> {{order.reddemed_coupon_order.coupon?' ('+order.reddemed_coupon_order.coupon.coupon_code+')':''}}</span>
            </td>
            <td align="center" class="text-danger">
              <span class="text-danger" v-html="currency"></span>
              <span class="text-danger">{{parseFloat((order.reddemed_coupon_order.original_price - order.reddemed_coupon_order.discount_price) || 0).toFixed(decimal)}}</span>
            </td>
          </tr>
          <tr class="saved-amount">
            <td colspan="4" align="center"><h6 class="text-right mb-0">{{trans.get('__JSON__.Total Amount')}}<span v-if="order.saved_amount > 0" class="you-saved">{{ trans.get('__JSON__.You Saved') }}</span></h6></td>
            <td align="center"> <span v-html="currency"></span> {{parseFloat(order.total_amount || 0).toFixed(decimal)}}<p class="save-amount" v-if="order.saved_amount > 0"><span v-html="currency" v-if="order.saved_amount > 0" class="you-saved"></span> <span v-if="order.saved_amount > 0" class="you-saved">{{parseFloat(order.saved_amount || 0).toFixed(decimal)}}</span></p></td>
          </tr>
        </tbody>
      </table>
    </div>
    <order-images :order="order" :loading="loading" v-if="!loading && $auth.setting.is_upload_order_image == 'Yes' && order.order_images && order.order_images.length > 0"/>
    <!-- View Detail Main End -->
  </div>
</template>
<style scoped>
.item-table-main .item-name-main{
  width: 48%;
}
.saved-amount .you-saved{
  color: #34c38f;
  margin-top: 10px;
}
.saved-amount h6{
    display: flex;
    justify-content: right;
    line-height: 18px;
    flex-direction: column;
}
.save-amount{
  margin-top:10px;
  margin-bottom: 0;
}
.saved-amount .tax-slab{
  margin-top: 10px;
}
</style>
